def door_open(settings):
    switch = list(settings)
    doors = []

    # can any door be opened?
    if switch[3] == "0" or switch[8] != "P":
        return doors

    # should the left door be opened?
    if switch[0] == "1" or switch[5] == "1":
        doors.append("left")
    elif switch[2] == "0" and switch[4] == "1":
        doors.append("left")

    # should the right door be opened?
    if switch[1] == "1" or switch[7] == "1":
        doors.append("right")
    elif switch[2] == "0" and switch[6] == "1":
        doors.append("right")

    return doors

if __name__ == "__main__":
    for n in range(256):
        code_1 = f'{bin(n)[2:].zfill(8)}P'
        code_2 = f'{bin(n)[2:].zfill(8)}D'
        #print(code_1,code_2)
        print(f'"{code_1}" : {door_open(code_1)},')
        print(f'"{code_2}" : {door_open(code_2)},')

    # should print ["left"]
    print(door_open("00010100P"))
